-- =============================================
-- Author	  :	Rahmat Setiawan <Arkamaya>
-- Create date: 27-08-2014
-- Description:	Get data for truck information panel
-- =============================================
CREATE PROCEDURE [dbo].[SP_GetTruckingInformationPanel]
AS
BEGIN
	
	SET NOCOUNT ON;
	
	DECLARE @TEMP_DOCK TABLE(
		DOCK_CD VARCHAR(5),
		STATION VARCHAR(3)
	)

	DECLARE @TEMP_TRUCKYARD TABLE(
		DOCK_CD VARCHAR(5),
		STATION VARCHAR(3),
		DOCK_STATUS VARCHAR(1)
	)

	DECLARE
	@DOCK_CD VARCHAR(5),
	@STATION VARCHAR(3),
	@ARRIVAL_PLAN_DT DATETIME,
	@ARRIVAL_ACTUAL_DT DATETIME,
	@DEPARTURE_PLAN_DT DATETIME,
	@DEPARTURE_ACTUAL_DT DATETIME,
	@DOCK_STATUS VARCHAR(1)

	INSERT INTO @TEMP_DOCK
	SELECT DISTINCT
	D.DOCK_CD, D.STATION 
	FROM TB_R_DELIVERY_CTL_D D
		INNER JOIN TB_M_DOCK DM ON DM.DOCK_CD = D.DOCK_CD AND DM.PLANT_CD = '5' AND DM.DOCK_CD NOT IN ('50', '57')
			AND RTRIM(CAST(D.DOCK_CD AS VARCHAR)) + RTRIM(CAST(D.STATION AS VARCHAR)) NOT IN ('551')
	WHERE D.STATION NOT IN ('0')
	ORDER BY 
		D.DOCK_CD, D.STATION
		
	DECLARE CURR_DOCK CURSOR FOR
		SELECT DOCK_CD, STATION FROM @TEMP_DOCK

	OPEN CURR_DOCK

	FETCH NEXT FROM CURR_DOCK INTO @DOCK_CD, @STATION

	WHILE @@FETCH_STATUS = 0
	BEGIN
		
		SELECT TOP 1 
			@ARRIVAL_PLAN_DT = ARRIVAL_PLAN_DT, @ARRIVAL_ACTUAL_DT = ARRIVAL_ACTUAL_DT, 
			@DEPARTURE_PLAN_DT = DEPARTURE_PLAN_DT, @DEPARTURE_ACTUAL_DT = DEPARTURE_ACTUAL_DT
		FROM TB_R_DELIVERY_CTL_D 
		WHERE DOCK_CD = @DOCK_CD AND STATION = @STATION AND ARRIVAL_PLAN_DT <= DATEADD(MINUTE, 15, GETDATE()) AND ARRIVAL_ACTUAL_DT IS NOT NULL
		ORDER BY ARRIVAL_PLAN_DT DESC
		
		IF (@ARRIVAL_PLAN_DT IS NULL)
		BEGIN
			SELECT TOP 1 
				@ARRIVAL_PLAN_DT = ARRIVAL_PLAN_DT, @ARRIVAL_ACTUAL_DT = ARRIVAL_ACTUAL_DT, 
				@DEPARTURE_PLAN_DT = DEPARTURE_PLAN_DT, @DEPARTURE_ACTUAL_DT = DEPARTURE_ACTUAL_DT
			FROM TB_R_DELIVERY_CTL_D 
			WHERE DOCK_CD = @DOCK_CD AND STATION = @STATION AND ARRIVAL_PLAN_DT <= GETDATE()
			ORDER BY ARRIVAL_PLAN_DT DESC	
		END
		
		IF ((@ARRIVAL_ACTUAL_DT IS NOT NULL) AND (@DEPARTURE_ACTUAL_DT IS NULL)) 
			SET @DOCK_STATUS = '1'
		ELSE
			SET @DOCK_STATUS = '0'
		
		INSERT INTO @TEMP_TRUCKYARD VALUES(@DOCK_CD, @STATION, @DOCK_STATUS)
		
		FETCH NEXT FROM CURR_DOCK INTO @DOCK_CD, @STATION
	END

	SELECT CASE WHEN DOCK_CD = '56' THEN '5657' ELSE DOCK_CD END AS DOCK_CD, STATION, DOCK_STATUS FROM @TEMP_TRUCKYARD
	
END

